#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
$sth=$dbh->query("LOCK TABLES rw_categories READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT category,count(rid) FROM rw_categories,rw_rings WHERE rw_categories.caid=rw_rings.caid GROUP BY category ORDER BY category");
while (($category,$number)=$sth->fetchrow)
{
	$category=~s/'/\\'/g;
	$hits{$category}+=$number;
	push (@categories,$category);
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth="";
$dbh="";
$i=0;
while($i<@categories)
{
	$result.="<tr>";
	$temp=$categories[$i];
	$hits{$temp}=0 if (!$hits{$temp});
	$categories[$i]=~s/\&/\%26/g;
	$categories[$i]=~s/ /\+/g;
	$result.="<td><a href=\"$cgi/rwbrowse.pl?cat=$categories[$i]\"><font size=2 color=white><b>$temp ($hits{$temp})</b></font></a></td>";
	$i++;
	if ($i<@categories)
	{
	$temp=$categories[$i];
	$hits{$temp}=0 if (!$hits{$temp});
	$categories[$i]=~s/ /\+/g;
	$categories[$i]=~s/\&/\%26/g;
	$result.="<td><a href=\"$cgi/rwbrowse.pl?cat=$categories[$i]\"><font size=2 color=white><b>$temp ($hits{$temp})</b></font></a></td>";
	$i++;
	}
	else
	{
	$result.="<td></td>";
	}
	$result.="</tr>";
}
$result="<tr><td colspan=2 align=center><font size=3 color=red><b>BROWSE CATEGORIES</b></font></td></tr>$result" if ($result);
print "HTTP/1.0 200 OK\n";
print "content-type: application/x-javascript\n\n";
print qq~document.write(\'$result\')\n~;

