#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

($webring,$suser,$euser,$method)=split("&",$ENV{QUERY_STRING});

if ($webring && $suser && $euser && $method)
{
	$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT rname,stype,status,rurl FROM rw_rings,rw_users WHERE (rid=$webring AND rw_users.uid=rw_rings.uid)");
	($fullrn,$stype,$status,$rurl)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if ($fullrn)
	{
		if ($status==1)
		{
			$sth=$dbh->query("LOCK TABLES rw_users READ, rw_sites READ") if ($locktables);
			if ($stype==1)
			{
				$sth=$dbh->query("SELECT rw_sites.uid,sname,surl,sdescr FROM rw_sites,rw_users WHERE (rid=$webring AND rw_sites.uid=rw_users.uid AND status=1) ORDER BY sname");
			}
			else
			{
				$sth=$dbh->query("SELECT rw_sites.uid,sname,surl,sdescr FROM rw_sites,rw_users WHERE (rid=$webring AND rw_sites.uid=rw_users.uid AND status=1)");
			}
			while (($uid,$sname,$uurl,$descr)=$sth->fetchrow)
			{
				push(@ndata,"$uid\t$sname\t$uurl\t$descr");
			}
			$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		}
		elsif ($status==2)
		{
			&closedb;
			push(@result,"<li>Sorry, webring <b>$fullrn</b> is temporary disabled</li>");
			push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
			open (F,"<$rwpath/template/sitelist.tpl");
			@html=<F>;
			close (F);
			$html=join("",@html);
			$html="print qq~$html~;";
			print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
			print "content-type: text/html\n\n";
			eval $html;
			exit;
		}
		else
		{
			&closedb;
			push(@result,"<li>Sorry, webring <b>$fullrn</b> is not approved yet</li>");
			push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
			open (F,"<$rwpath/template/sitelist.tpl");
			@html=<F>;
			close (F);
			$html=join("",@html);
			$html="print qq~$html~;";
			print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
			print "content-type: text/html\n\n";
			eval $html;
			exit;
		}
	}
	else
	{
		&closedb;
		push(@result,"<li>Sorry, webring is not exits</li>");
		push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
		open (F,"<$rwpath/template/sitelist.tpl");
		@html=<F>;
		close (F);
		$html=join("",@html);
		$html="print qq~$html~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $html;
		exit;
	}
}
else
{
	&closedb;
	push(@result,"<li>Sorry, webring code on website you come from is broken</li>");
	push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
	open (F,"<$rwpath/template/sitelist.tpl");
	@html=<F>;
	close (F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
	exit;
}
if (@ndata)
{
@data=@ndata;
@ndata=();
$i=1;
while ($i<scalar(@data))
{
	($uname)=split("\t",$data[$i]);
	if ($suser eq $uname)
	{
		$sitem=$i;
	}
	if ($euser eq $uname)
	{
		$eitem=$i;
	}
	$i++;
}
$icount=scalar(@data);
$i=0;
while ($i<5)
{
	$eitem=$eitem+1;
	if ($eitem==scalar(@data))
	{
		$eitem=0;
	}
	$sitem=$sitem-1;
	if ($sitem<0)
	{
		$sitem=scalar(@data)-1;
	}
	push (@next,$eitem);
	unshift (@prev,$sitem);
	$i++;
}
if ($method eq "next")
{
	foreach(@next)
	{
		($username,$title,$uurl,$desc)=split("\t",$data[$_]);
		push(@result,"<li><a href=\"$uurl\"><font face=\"Arial\" size=\"2\">$title</font></a><br><font face=\"Arial\" size=\"2\">$desc</font></li>\n");
	}
	($suser)=split("\t",$data[$next[0]]);
	($euser)=split("\t",$data[$next[4]]);
}
if ($method eq "prev")
{
	foreach(@prev)
	{
		($username,$title,$uurl,$desc)=split("\t",$data[$_]);
		push(@result,"<li><a href=\"$uurl\"><font face=\"Arial\" size=\"2\">$title</font></a><br><font face=\"Arial\" size=\"2\">$desc</font></li>\n");
	}
	($suser)=split("\t",$data[$prev[0]]);
	($euser)=split("\t",$data[$prev[4]]);
}
push(@footer,"<table width=\"100%\" border=0><tr>");
push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/rworldfs.pl?$webring&$suser&$euser&prev\"><img src=\"$ringworld/images/rwprev.gif\" border=0></a></td>");
push(@footer,"<td width=\"70%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td>");
push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/rworldfs.pl?$webring&$suser&$euser&next\"><img src=\"$ringworld/images/rwnext.gif\" border=0></a></td>");
push(@footer,"</tr></table>");
&closedb;
open (F,"<$rwpath/template/sitelist.tpl");
@html=<F>;
close (F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
}
else
{
	&closedb;
	push(@result,"<li>Sorry, webring is empty</li>");
	push(@footer,"<table width=\"100%\" border=0><tr><td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td></tr></table>");
	open (F,"<$rwpath/template/sitelist.tpl");
	@html=<F>;
	close (F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
	exit;
}
sub closedb
{
$sth="";
$dbh="";
}
